//#include "msp430x14x.h"
#include "hardware.h"
#include <stdlib.h>
#include <stdio.h>
//#include "msp430def.h"
#include "zyl2.c"
//#include "cdef.h"



/***************************************************************************
*    Variablen                                                             *
****************************************************************************/

bool bTimerClick; /*
* Description : wird von der Timer-ISR gesetzt
*/

/*#pragma interrupt_handler timera_0_isr:TAIV
void timera_0_isr(void){
	     bTimerClick = 1;
     }
*/
wakeup interrupt (TIMERA0_VECTOR) INT_TimerA_CCR0(void) {
    CCR0 += ONESECOND;                  //setup next irq
    bTimerClick = 1;
    }


void vTimeraInit1( void ){
     TACTL = TASSEL2 + TACLR;      /* SMCLK, clear TAR */
     TACTL = TAIE;                 /* CCR0 interrupt enable */
     TACCR0 = 20000;                 /* 2,5 ms Timer Click */
     TACTL |= MC0;                 /* Up-Mode */
     }
void vTimeraInit2( void ){
/* EasyCASE - */
   TACTL  = TASSEL0+TACLR;                 // Timer init ACLK
   CCR0   = 512;                           // 64 us
   CCTL0  = CCIE|OUT;                      // video line interrupt
   CCTL1  = 0;
   CCTL2  = 0;
//   CCTL1  = OUTMOD2;                       // set toggle mode
   TACTL  |= MC0;                          // Start timer up mode
   /* EasyCASE ) */
}


void vTimeraInit3( void ){
    BCSCTL1 |= DIVA0 | DIVA1;           //setup divider for RTC
    TACTL  = TACTL_INIT;                //setup timer (still stopped)
    CCR0   = ONESECOND;                 //setup first RTC irq
    CCTL0  = CCIE;                      //enable compare interrupts
    CCTL1  = 0;                         //the other modules are not used
    CCTL2  = 0;                         //...
    TACTL  |= MC1;                      //start timer
}


void vClockInit( void ){
     word w;
     // DCOCTL  = 0x00;
     WDTCTL = WDTPW + WDTHOLD;     /* Watchdog deaktivieren */
#if 1
     P5DIR |= 0x10;                /* 8MHz-CLK am Pin 48 */
     P5SEL |= 0x10;
     P5DIR |= 0x20;                /* SMCLK an Pin 49 */
     P5SEL |= 0x20;
#endif
     BCSCTL1 &= ~XT2OFF;           /* Oszillator on */
     do  {
          IFG1 &= ~OFIFG;
          for(w = 0xff; w > 0; w--);
          }
     while((IFG1 & OFIFG) != 0);
     BCSCTL2 = 0x88;
//     BCSCTL2 |= SELM1 + SELS + DIVS0;   /* nun los */
     }
void wait(int time)          //delay function
{
  if (time<0) time=0;
  volatile int i;        //declare i as volatile int
  for(i=0;i<time;i++);  //repeat 32000 times
}

int main(void){
	int i;

	//Port 1 initialisieren
     P1OUT   = 0xFF;               /* LEDs */
     P1DIR   = 0xFF;
     P1IES   = 0x00;
     P1IE    = 0x00;
     P1SEL   = 0x00;
	//Port 2 initialisieren
     P2OUT   = 0xFF;               /* LEDs */
     P2DIR   = 0xFF;
     P2IES   = 0x00;
     P2IE    = 0x00;
     P2SEL   = 0x00;


//	wait(5000);
	DINT();						/* Interrupts deaktivieren */
	vClockInit();				/* Watchdog deaktivieren */
	vTimeraInit3();				/* Timer A initialisieren */
	bTimerClick = 0;
	EINT();						/* Interrupts aktivieren */
	while(1){					/* Endlosschleife */
		mcBlueOff();
	    mcGreenOff();

		mcRedOff();
		wait(2000);
		mcRedOn();
		wait(2000);

		if(bTimerClick==1){		/* Nach Interrupt auf Timer A*/
			bTimerClick=0;
	        //mcGreenOn();		/* Alle LED aufblinken lassen*/
	        mcBlueOn();
	        //mcRedOn();
	        wait(250);

		}
	  }
  }
